﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace DemoCleaner
{
    public partial class Form1 : Form
    {
        string movedir = "";
        string getpath = "";

        public struct maphys 
        {
            public string t1;
            public string t2;
            public string t3;
            public string people;
            public string maph;
            public FileInfo str;
        }



        public Form1()
        {
            InitializeComponent();
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton3.Checked)
            {
                FolderBrowserDialog demosBrowz = new FolderBrowserDialog();
                demosBrowz.Description = groupBox2.Text;
                demosBrowz.SelectedPath = textBox1.Text;
                if (demosBrowz.ShowDialog() == System.Windows.Forms.DialogResult.OK && demosBrowz.SelectedPath.Length > 0)
                {
                    movedir = demosBrowz.SelectedPath;
                    movedir = sl(movedir + "\\");
                }
            }
            else movedir = "";
        }

        private void radioButton5_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton5.Checked)
            {
                FolderBrowserDialog demosBrowz = new FolderBrowserDialog();
                demosBrowz.Description = groupBox3.Text;
                demosBrowz.SelectedPath = textBox1.Text;
                if (demosBrowz.ShowDialog() == System.Windows.Forms.DialogResult.OK && demosBrowz.SelectedPath.Length > 0)
                {
                    textBox1.Text = demosBrowz.SelectedPath;
                    textBox1.Text = sl(textBox1.Text + "\\");
                }
            }
            else textBox1.Text = getpath;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            getpath = Application.ExecutablePath.Substring(0, Application.ExecutablePath.Length - Path.GetFileName(Application.ExecutablePath).Length);
            textBox1.Text = getpath;
        }

        private string sl(string dir)
        {
            dir = dir.Replace("\\\\", "\\");
            return dir;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                DirectoryInfo filedemos = new DirectoryInfo(textBox1.Text);
                int i1 = 0, i2 = 0, i3 = 0, i4 = 0;
                if (filedemos.Exists)
                {
                    progressBar1.Value = 0;
                    progressBar1.Maximum = filedemos.GetFiles().Length;
                    List<maphys> onemap = new List<maphys>();
                    string map = "";
                    
                    foreach (FileInfo NextFile in filedemos.GetFiles())
                    {
                        progressBar1.Value++;
                        if (NextFile.Extension == ".dm_68" || NextFile.Extension == ".dm_67")
                        {
                            i1 = i2 = i3 = 0;
                            i1 = NextFile.Name.IndexOf("]");
                            if (i1 > 0) i2 = NextFile.Name.IndexOf("(", i1);
                            if (i2 > 0) i3 = NextFile.Name.IndexOf(".", i2);
                            if (i1 > 0) i4 = NextFile.Name.IndexOf(")", i1);
                            if (i1 > 0 && i2 > 0 && i4 > 0)
                            {
                                
                                maphys dem = new maphys();
                                dem.maph = NextFile.Name.Substring(0, i1);
                                dem.t1 = NextFile.Name.Substring(i1 + 1, 2);
                                dem.t2 = NextFile.Name.Substring(i1 + 4, 2);
                                dem.t3 = NextFile.Name.Substring(i1 + 7, 3);
                                if(i3>0) dem.people = NextFile.Name.Substring(i2 + 1, i3 - (i2 + 1) );
                                else dem.people = NextFile.Name.Substring(i2 + 1, i4 - (i2 + 1));
                                dem.str = NextFile;

                                
                                
                                if (map != dem.maph) 
                                {
                                    eqmaph(onemap);
                                    onemap.Clear();
                                    map = dem.maph;
                                }


                                onemap.Add(dem);
                            }
                        }
                    }
                    eqmaph(onemap);
                    MessageBox.Show("Demos was cleared", "Complete", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    MessageBox.Show("Directory error", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            catch (Exception ex) { MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error); }
        }


        private void eqmaph(List<maphys> maph) 
        {
            if (radioButton2.Checked)
            {
                while (maph.Count > 0)
                {
                    List<maphys> people = new List<maphys>();
                    string peop = maph[0].people;
                    for (int i = 0; i < maph.Count; i++) 
                    {
                        if(peop == maph[i].people) people.Add(maph[i]);
                    }

                    for (int i = maph.Count-1; i >= 0; i--)
                    {
                        if (peop == maph[i].people) maph.RemoveAt(i);
                    }

                    eqtime(people);
                }
            }
            else 
            {
                eqtime(maph);
            }
        }

        private void eqtime(List<maphys> maph)
        {
            for (int i = 1; i < maph.Count; i++) 
            {
                if (radioButton3.Checked == false)
                    maph[i].str.Delete();
                else maph[i].str.MoveTo(movedir + maph[i].str.Name);
            }
        }


    }
}
